#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/param.h>

#define LXCPATH "/var/lib/lxc"

static int is_volatile(const char *name)
{
	char *path;
	int ret;

	if (asprintf(&path, LXCPATH "/%s", name) < 0)
		return -1;

	ret = access(path, F_OK);

	free(path);

	return !!ret;
}

int main(int argc, char *argv[])
{
	const char *file = "/proc/net/unix";
	const char *format = "%*lx: %*x %*x %*d %*d %*d %*d @" LXCPATH "/%s";
	char buffer[MAXPATHLEN];
	FILE *f;
	int ret;

	f = fopen(file, "r");
	if (!f) {
		perror("fopen '%s' failed");
		return -1;
	}

	for (ret = fscanf(f, "%*[^\n]"); ret != EOF; ret = fscanf(f, format, buffer)) {

		char *aux;

		if (!ret) {
			ret = fscanf(f, "%*[^\n]");
			continue;
		}

		aux = strchr(buffer, '/');
		*aux = '\0';

		printf("%s : [%sregistered]\n", buffer, is_volatile(buffer) ?
			"not " : "");
	}

	fclose(f);
	
	return 0;
}
